#!/usr/bin/env perl
#
#  chstructure.pl
#  2004-12-23 stvo 
#  $Id: chstructure.pl,v 1.3 2022/11/21 11:47:45 testx Exp testx $
#
use warnings;
use strict;

# use Data::Dumper;

$| = 1;

#
#  print level
#
my $PRLEV = 2;

my $files = { };

my %plain = (
   D => 'Verzeichnis',
   F => 'Datei',
   L => 'Symbolischer Link',
   S => 'Pipe/Socket',
   c => 'character special',
);

my $prefix = "";
my %allobjs;
sub traversedir ($);
sub traversedir ($)
{
   my $dir = shift;

#   print "DIR=", $prefix . $dir, "\n";
   opendir (DIR, $prefix . $dir) or do {
      warn "cannot open ", $prefix . $dir, "\n";
      return;
   };
   my @dirents = readdir DIR;
   closedir DIR;
#
#     depth first/process directories
#     do not follow symbolic links
#     and try to stay local FIXME: not yet impl.
#
   for my $d (sort @dirents) {
      my $ndir = $dir . '/' . $d;
      next if ($d eq '.' or $d eq '..');

      lstat $prefix . '/' . $ndir;
      if (-l _) {
         $allobjs {$ndir} = 'L';
#    print $ndir, " L\n";
      }
      elsif (-f _) {
#
# ignore ordinary files
#
      }
      elsif (-d _) {
         $allobjs {$ndir} = 'D';
#   print $ndir, " D\n";
         traversedir ($ndir);
      }
      elsif (-p _) { # pipe
         $allobjs {$ndir} = 'S';
#         print $ndir, " S\n";
      }
      elsif (-S _) { # socket
         $allobjs {$ndir} = 'S';
#         print $ndir, " S\n";
      }
      elsif (-c _) { # char special
         $allobjs {$ndir} = 'c';
#         print $ndir, " c\n";
      }
   }
}


sub usage ()
{
   print "chstructure.pl oldpath newpath\n";
   exit 1;
}

sub main ()
{
   my $orig = $ARGV [0];
   my $new = $ARGV [1];

   my $rc = 0;

   usage () if (not defined $orig or not defined $new);

   $prefix=$orig;
   traversedir '';
   my %old = %allobjs;

   $prefix=$new;
   traversedir '';

   for my $i (sort keys %allobjs) {
      if (defined $old{$i} and $old{$i} ne $allobjs{$i}) {
         print $i, ": alt:", 
            $plain{$old{$i}}, ", zu importieren:", 
            $plain{$allobjs{$i}}, "\n";
         $rc |= 1;
      }
   }

   exit $rc;

#   open (FO, ">STRUCTURE") or die "cannot open file: $!";
#   print FO Dumper \%allobjs;
#   close (FO);
}

main ();
