#!/usr/bin/perl -w

use strict;

my $file = shift;

my ($user) = $file =~ m:^/home/(\w+)/:;

unless (defined $user) {
    die "No such user\n";
}

my ($uid,$gid) = (getpwnam($user))[2,3];

unless (defined $uid) {
    die "No such user $user\n";
}

if ($uid == 0) {
    die "Executed as user root\n";
}

$( = $gid; $) = $gid; $< = $uid; $>=$uid;
system "cp $file $file~@{[time]}";

open HTA, "+<$file" or die "$file: $!";
flock HTA, 2;
my $remove_rewrite_directives = 0;
my $htaccess = '';
my $modified = 0;
while (<HTA>) {
    chomp;
    $remove_rewrite_directives = 1 if ($_ eq '#PD-ADMIN-ERRORDOCS BEGIN');
    $remove_rewrite_directives = 0 if ($_ eq '#PD-ADMIN-ERRORDOCS END');
    if ($_ !~ /^Rewrite/i or not $remove_rewrite_directives) {
        $htaccess .= "$_\n";
    } else {
        $modified = 1;
    }
}
exit unless $modified;
seek HTA, 0, 0;
print HTA $htaccess;
truncate HTA, tell HTA;
close HTA;
