#!/bin/bash
#
#  ipv6prep.sh
#  2011-08-01 stvo
#
#  $Id: ipv6prep.sh,v 1.2 2011/08/01 18:32:59 testx Exp testx $
#

#
#  remove tcp-env which unsets TCPREMOTEHOST in some IPv6 cases
#
if grep -q tcp-env /service/qmail-smtpd/run ; then
   echo "tcp-env wird aus /service/qmail-smtpd/run entfernt"
   sed "s,/var/qmail/bin/tcp-env,," /service/qmail-smtpd/run > /service/qmail-smtpd/run~
   mv /service/qmail-smtpd/run~ /service/qmail-smtpd/run
   chmod +x /service/qmail-smtpd/run
fi

#
#  recompile ucspi-tcp with IPv6 patch
#
test -e /usr/local/bin/tcpserver && /usr/local/bin/tcpserver -h 2>&1 | grep -q 461 || {

   PFS=/usr/src
   pushd $PFS
   while true; do

      echo "ucspi-tcp wird fuer IPv6 neu uebersetzt"
      wget --tries=3 -nc -i - <<EOT
http://download.pd-admin.de/tp/ucspi-tcp-0.88.tar.gz
http://download.pd-admin.de/tp/ucspi-tcp-0.88-ipv6.diff19
EOT
      RV=$?
      if [ $RV -ne 0 ]; then
         echo "file fetching failed, try again later"
         break
      fi
      rm -fr ucspi-tcp-0.88
      tar -xzf $PFS/ucspi-tcp-0.88.tar.gz
      cd ucspi-tcp-0.88

      patch -p1 -i $PFS/ucspi-tcp-0.88-ipv6.diff19 || {
         echo "kann ucspi-tcp-0.88-ipv6.diff19 nicht anwenden"   
         break
      }

      make && make setup check || {
         echo "kann ucspi-tcp-0.88.tar.gz nicht kompilieren"
         break
      }

   break
   done
   popd
}
