#!/usr/local/pd-admin2/bin/perl
#
#  pwhashupgrade.pl -- enforce new hashes for known passwords
#  2012-10-26 stvo
#  $Id: pwhashupgrade.pl,v 1.2 2012/10/31 15:30:02 testx Exp testx $
#

use warnings;
use strict;
use DBI;

open (F, '<', '/opt/pdadmin/etc/mysql_rootpw.conf') or die "open: $!";
chomp (my $rootpw = <F>);
close (F) or die "close: $!";

open (F, '<', '/var/qmail/vadmin-check.pl') or die "open: $!";
my $text = join '', <F>;
close (F) or die "close: $!";
my %nvhash = $text =~ /^\s*\$([a-z]+)\s*=\s*"([A-Za-z0-9\.\/]*)"/gm;

die "syntax error in vadmin-check.pl\n" unless %nvhash;
die "key 'database' not in vadmin-check.pl\n"
   unless exists $nvhash{'database'};
my $db = $nvhash{'database'};
die "unknown database '$db'\n" unless $db eq 'vadmin';
die "key 'password' not in vadmin-check.pl" 
   unless exists $nvhash{'password'};
my $vapw = $nvhash{'password'};

my $dsn =  "DBI:mysql:database=mysql;host=localhost;";
my $d = DBI->connect ($dsn, 'root', $rootpw);
die "connect failed" unless $d;

my $s = $d->prepare (q/
   UPDATE user
   SET password = PASSWORD(?)
   WHERE password = OLD_PASSWORD(?) AND user = ?
/);
my $n;
$n = $s->execute ($vapw, $vapw, 'vadmin') or die "execute: $!\n";
$n += 0;
print "vadmin: $n passwords updated\n";
$n = $s->execute ($rootpw, $rootpw, 'root') or die "execute: $!\n";
$n += 0;
print "root: $n passwords updated\n";
$d->do ('FLUSH PRIVILEGES') or die "FLUSH PRIVILEGES failed";
$d->disconnect;
