#!/bin/bash
#
#  Ticket 1523594
#  2019-09-16 stvo
#  $Id: ticket-1523594.sh,v 1.4 2019/10/23 11:14:38 testx Exp testx $
#
set -Ceuo pipefail
#set -x
INST=/usr/local/pd-admin2
source $INST/SETENV
RCM=$INST/htdocs/roundcubemail

function my 
{
   mysql -p$(cat /opt/pdadmin/etc/mysql_rootpw.conf) "$@"
}

rcmusers=($(my -NBe "select User from mysql.db where Db = 'roundcubemail' and Host = 'localhost'"))
#echo "rcmusers = <${rcmusers[@]}>"

function grant 
{
   for u in "${rcmusers[@]}"; do
#      echo $u
      my -NBe "grant create, alter, drop, references on roundcubemail.* to '$u'@'localhost'"
   done
}

function revoke
{
   for u in "${rcmusers[@]}"; do
#      echo $u
      my -NBe "revoke create, alter, drop, references on roundcubemail.* from '$u'@'localhost'"
   done
}

function update
{
   ln -snf $INST/bin/php-7.3-cli ${RCM}/bin/php
   local PATH=${RCM}/bin:$PATH
#   type -p php
   ${RCM}/bin/update.sh -y </dev/null
   rm ${RCM}/bin/php
}

function finish_ownership_and_permissions
{
   chown root:rndcbml ${RCM}/config/config.inc.php
   chmod 0440 ${RCM}/config/config.inc.php
   for o in main.old.php db.old.php; do
      f=${RCM}/config/$o
      if [ -f "$f" ]; then
         chmod 0440 "$f"
      fi
   done
}

function there_are_no_roundcube_permissions
{
   if [ -z ${rcmusers+x} ]; then
      true
      return
   fi
   false
}

function there_are_no_config_files
{
   if [ -f ${RCM}/config/config.inc.php -o -f ${RCM}/config/main.inc.php ]; then
      false;
      return
   fi
   true
}

function Ticket_2019102267002761
{
   sed -i "s,\$config\['smtp_server'\] =.*,\$config['smtp_server'] = '127.0.0.1';," /usr/local/pd-admin2/htdocs/roundcubemail/config/config.inc.php
}

function append_user_and_password_if_necessary
{
   if ! grep -q smtp_user ${RCM}/config/config.inc.php; then
      cat <<'_' >> ${RCM}/config/config.inc.php
$config['smtp_user'] = '%u';
_
      echo "smtp_user = %u added"
   fi
   if ! grep -q smtp_pass ${RCM}/config/config.inc.php; then
      cat <<'_' >> ${RCM}/config/config.inc.php
$config['smtp_pass'] = '%p';
_
      echo "smtp_pass = %p added"
   fi
   if ! grep -q smtp_port ${RCM}/config/config.inc.php; then
      cat <<'_' >> ${RCM}/config/config.inc.php
$config['smtp_port'] = 587;
_
      echo "smtp_port = 587 added"
   fi
}

function main
{
   if there_are_no_roundcube_permissions; then
      echo "no roundcube permissions found"
      return
   fi
   if there_are_no_config_files; then
      echo "no roundcube config files found"
      return
   fi
   grant
   update
   revoke
   if Ticket_2019102267002761; then
      echo "Ticket_2019102267002761 returned true"
   else
      echo "Ticket_2019102267002761 returned false"
   fi
   append_user_and_password_if_necessary
   finish_ownership_and_permissions
}

main
