#!/bin/bash
#  Ticket 1524289
#  managesieve Plugin fuer Roundcube 
#  2021-06-08 stvo
#  merge config template with current config
#  $Id: ticket-1524289.sh,v 1.2 2021/06/08 13:31:22 testx Exp testx $
set -Ceuo pipefail
#set -x

inst=/usr/local/pd-admin2
php=$inst/bin/php-7.4-cli
cnf=$inst/htdocs/roundcubemail/config/config.inc.php
cnf_template=$inst/htdocs/roundcubemail/config/config.inc.php.sample

tmpfile=$(mktemp "$cnf.XXXXXXXX")
chown root:rndcbml "$tmpfile"
chmod 0640 "$tmpfile"

$php <<_ >|$tmpfile
<?php 

include "$cnf_template";
\$config_template = \$config;
include "$cnf";

\$config = array_replace_recursive (\$config_template, \$config);
echo "<?php\n\\\$config = ";
var_export (\$config);
echo ";\n";
_

oldmd5=($(md5sum "$cnf"))
newmd5=($(md5sum "$tmpfile"))

if [[ ${oldmd5[0]} != ${newmd5[0]} ]]; then
   mv --backup=numbered "$tmpfile" "$cnf"
   echo "$cnf written"
else
   rm -f "$tmpfile"
fi
